/*
 *  Copyright 2001 Adrian Thurston <adriant@ragel.ca>
 */

/*  This file is part of Ragel.
 *
 *  Ragel is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 * 
 *  Ragel is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *  You should have received a copy of the GNU General Public License
 *  along with Ragel; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 */

#ifndef _FSM_H
#define _FSM_H

#include "fsmgraph.h"
#include <iostream>

using std::ostream ;

struct State;
struct Trans : public FsmTrans< State, Trans > { };
struct State : public FsmState< State, Trans > { };
typedef FsmGraph< State, Trans > Fsm;

/* Print an fsm to out stream. */
void dumpGraph( ostream &out, Fsm *fsm );

#endif /* _FSM_H */
